=== debian/changelog ===
paraview (5.0.1+dfsg1-4) unstable; urgency=high

  * [7451182] Roll back to Qt4. (Closes: #821091)
  * [b77e3ee] Build documentation. (Closes: #820455)

 -- Anton Gladky <gladk@debian.org>  Sat, 16 Apr 2016 01:01:02 +0200

paraview (5.0.1+dfsg1-3) unstable; urgency=medium

  [ Graham Inggs ]
  * [5bb46bd] Fix typo in dependencies of paraview-dev. (Closes: #820448)

 -- Anton Gladky <gladk@debian.org>  Fri, 08 Apr 2016 17:21:49 +0200

paraview (5.0.1+dfsg1-2) unstable; urgency=medium

  * [2a1316c] Add missing build-dependency libqt5sql5-sqlite.

 -- Anton Gladky <gladk@debian.org>  Thu, 07 Apr 2016 19:49:59 +0200

paraview (5.0.1+dfsg1-1) unstable; urgency=medium

  * [b3f3619] Use dpkg-buildflags. Should fix reproducibility.
  * [839465d] Fix typo in d/copyright.
  * [55f10bf] Imported Upstream version 5.0.1+dfsg1
  * [8c95453] Refresh patches.
  * [5d50cf5] Switch to Qt5. (Closes: #784505)
  * [18c7f23] Apply cme fix dpkg.

 -- Anton Gladky <gladk@debian.org>  Wed, 06 Apr 2016 20:20:29 +0200
